package io.islandtime.codegen

import com.squareup.kotlinpoet.FileSpec
import kotlin.reflect.KClass

fun FileSpec.Builder.addHeader(jvmName: String): FileSpec.Builder {
    addAnnotation(JvmMultifileClass::class)
    addAnnotation(buildAnnotationSpec(JvmName::class) {
        addMember("%S", jvmName)
    })
    addComment("\nThis file is auto-generated by 'tools:code-generator'\n")
    return this
}

val KClass<*>.zero: String
    get() = when (this) {
        Long::class -> "0L"
        Float::class -> "0.0f"
        Double::class -> "0.0"
        else -> "0"
    }